//  RReport
//  Copyright (C)
//
//  Java4Less@Confluencia.net
//  All rights reserved
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - You may not copy and paste any code into external files.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material


using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace J4L.RReport {
	
	public class ReportWebControl: WebControl {	
		
	// report template file
	string m_repFile="";		

	// report format, PDF or HTML
	string m_format="HTML";
		
	// output pdf file name
	string m_pdfFile="report.pdf";		
		
	[Description("Report template file"), Category("Data")]
	public  string reportFile {
		get {
			return m_repFile;
		}
		set {
			m_repFile=value;
		}
		}
		
	[Description("Format"), Category("Data")]
	public  string format {
		get {
			return m_format;
		}
		set {
			m_format=value;
		}
		}	
		
	[Description("PDF File"), Category("Data")]
	public  string pdfFile {
		get {
			return m_pdfFile;
		}
		set {
			m_pdfFile=value;
		}
		}		
		
	protected override void Render(HtmlTextWriter writer) {
		
	
       // load report from file
		Report rep=new Report();

 		if (!rep.importReport(m_repFile)) {
 			writer.Write("Error loading "+m_pdfFile);
 			return;
 		}
 		
                
        if (format.ToUpper().CompareTo("PDF")!=0) rep.setDHTMLActive(true); // use dhtml 

        rep.disablePrinting(true);

        rep.prepare();

        rep.endReport();
		
		if (format.ToUpper().CompareTo("PDF")==0) {
			rep.exportPDF(m_pdfFile);
			
			writer.Write("<a href=\""+m_pdfFile+"\">" + m_pdfFile + " </a>");
		}
		else {

        	// get dthml output
        	string htmlString= rep.getHTML();                    		
		
			writer.Write(htmlString);
		}
   
   }
		
	
	}
}
