Imports J4L.RReport
Imports System
Imports System.IO
Imports System.Drawing
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Module MyModule2 


public class examplePDFOrder: implements RAreaListener

private total as integer 	

 ' data arrays
dim  columnsNames as string() = {"Article", "Description","Priority","Quantity","Price"}

dim columnsData as object(,)={{"A0301", "Printer XXX", "0", 300, 30.9 }, {"B0301", "CD-ROM writer","2",  200, 3.0},{"C0405", "Laptop SP","1",  330, 4500.9},{"D1001", "Mouse 45","0",  100, 23.08}, {"E3044", "Keyboard Ms 250","0",  300, 223.901},{"F9902", "Mouse PS2","0",  1300, 34},{"G2387", "Laser printer LP300","0",  3200, 56.09},{"H0993", "Laser printer LP200","1",  200, 3.93}}

 public sub init() 
	 
 		' load report from file
		Dim report as Report
		
		report=new Report()

        Console.WriteLine("loading report")
 		if (not report.importReport("c:\j4l\RReportNET\examples\PDF_DHTML\order.rep")) then
 			Console.WriteLine("Error, could not load file")
 			end
 		end if

		report.getAreaByName("Detail").setListener(me)
		' set the values for the header programatically
		report.getReportHeader().getItemByName("Number").setruntimeValue("111")
		report.getReportHeader().getItemByName("Date").setruntimeValue("10/10/2000")
		report.getReportHeader().getItemByName("Company").setruntimeValue("COMPANY PLC")
		report.getReportHeader().getItemByName("City").setruntimeValue("London")
		report.getReportHeader().getItemByName("address").setruntimeValue("Street 2")

		' we use the Array as data source
		report.getAreaByName("Detail").setDataSource(new RArraySource(columnsNames,columnsData))

		' set listener to calculate amounts on the fly
		report.getReportFooter().setListener(me)

        exportPDF(report)
       ' exportDHTML(report)

		end
 end sub

 sub exportPDF(rep as Report) 

                rep.disablePrinting(true)
         		rep.prepare()
                Console.WriteLine("finishing report")
		        rep.endReport()
                Console.WriteLine("File exported: REPORT.PDF")
  				rep.exportPDF("report.pdf")
 end sub


 sub exportDHTML(rep as Report) 
              
                rep.setDHTMLActive(true) 

                rep.disablePrinting(true)

         		rep.prepare()

                Console.WriteLine("finishing report")

		        rep.endReport()

                Console.WriteLine("Writing to html file")

                ' get dthml output
                dim htmlString as string
                htmlString= rep.getHTML()
                
                dim out2 as StreamWriter 
                
          		out2= new StreamWriter("report.html")
    	  		out2.Write(htmlString)
	      		out2.Close()
                   
            	Console.WriteLine("File exported: REPORT.HTML")
	end sub


Overridable sub beforePrintingArea(area As RArea)  Implements RAreaListener.beforePrintingArea
	 Dim price as Double
	 Dim quantity as Integer
	 
   ' calculate the amount	of each line
	 if (area.getName()="Detail") then
    	 price= area.getItemByName("Price").getruntimeValue()
		 quantity=area.getItemByName("Quantity").getruntimeValue()
		 total= (total+(quantity*price))
		 area.getItemByName("Amount").setruntimeValue( quantity*price)
	 end if
	 
   ' set total amount
	 if (area.getName()="Footer") then
		 area.getItemByName("Total").setruntimeValue( total)
		 total=0
	 end if
 
 end sub 

end class


end Module
